/*************************** (C) COPYRIGHT 2014 GLHF ****************************
 * 文件名  ：USART4.c
 * 描  述  ：串口4驱动代码   
 * 版  本  ：V1.0
 * 作  者  ：XuZhongPing
 * 日  期  ：2017/09/03 
*********************************************************************************/
#include "usart4.h"

uint8_t USART4_RX_BUF[USART4_RECV_LEN];			//最大接收缓存
uint8_t USART4_TX_BUF[USART4_SEND_LEN];			//最大发收缓存
uint8_t USART4_RX_STA = 0;       						//接收状态标记

void USART4_ReceiveHandler(uint8_t rxBuf[], uint8_t bData);
/*
***********************************************************************
*	函 数 名: USART4_Init
*	功能说明: 初始化IO 串口4
*	形    参：bound:波特率	 
*	返 回 值: 无
***********************************************************************
*/
void USART4_Init(u32 bound)
{  	
	//GPIO端口设置
	GPIO_InitTypeDef GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;
	 
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);		//使能GPIOA时钟
 	RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART4, ENABLE);		//使能USART4时钟

	//USART4_TX   PC.10
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10; 							//PC.10
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;					//复用推挽输出
	GPIO_Init(GPIOC, &GPIO_InitStructure); 									//初始化PC.10
   
	//USART4_RX	  PC.11
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;		//浮空输入
	GPIO_Init(GPIOC, &GPIO_InitStructure);  								//初始化PC.11

	//USART 初始化设置
	USART_InitStructure.USART_BaudRate = bound;																			//设置波特率;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;											//字长为8位数据格式
	USART_InitStructure.USART_StopBits = USART_StopBits_1;													//一个停止位
	USART_InitStructure.USART_Parity = USART_Parity_No;															//无奇偶校验位
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;	//无硬件数据流控制
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;									//收发模式
	USART_Init(UART4, &USART_InitStructure); 																				//初始化串口
	
	//Usart4 NVIC 配置
	NVIC_InitStructure.NVIC_IRQChannel = UART4_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1 ;		//抢占优先级0
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;					//子优先级1
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;							//IRQ通道使能
	NVIC_Init(&NVIC_InitStructure);															//根据指定的参数初始化VIC寄存器
  
	USART_ITConfig(UART4, USART_IT_RXNE, ENABLE);			//开启中断
	USART_Cmd(UART4, ENABLE);													//使能串口 									  	
}

/*
***********************************************************************
*	函 数 名: USART4_IRQHandler
*	功能说明: 串口4中断服务程序
*	形    参：无
*	返 回 值: 无
***********************************************************************
*/
void UART4_IRQHandler(void)
{
	uint8_t res = 0;
	
	if(USART_GetITStatus(UART4, USART_IT_RXNE) != RESET)
	{
		res = USART_ReceiveData(UART4);			//读取接收到的数据
		USART4_ReceiveHandler(USART4_RX_BUF, res);
	}	
}

/*
***********************************************************************
*	函 数 名: USART4_SendByteData
*	功能说明: 发送一字节数据
*	形    参: 无
*	返 回 值: 无
***********************************************************************
*/
void USART4_SendByteData(uint8_t bData)
{ 
	USART_SendData(UART4, bData);
	while(USART_GetFlagStatus(UART4, USART_FLAG_TC) != SET);		//等待发送结束
}	

/*
***********************************************************************
*	函 数 名: USART4_SendFrameData
*	功能说明: 发送一帧数据
*	形    参: pData -> 数据的首地址；len -> 数据的长度
*	返 回 值: 无
***********************************************************************
*/
void USART4_SendFrameData(uint8_t pDataBuf[], uint16_t len)
{
	uint16_t i = 0;
	
	USART_ClearFlag(UART4, USART_FLAG_TC);
	for(i = 0; i < len; i++)
	{
		USART4_SendByteData(pDataBuf[i]);
	}
}	

/*
***********************************************************************
*	函 数 名: USART4_ReceiveHandler
*	功能说明: 串口数据接收处理程序
*	形    参: 传入串口接收到的数据
*	返 回 值: 无（影响串口接收状态USART4_RX_STA）
***********************************************************************
*/
void USART4_ReceiveHandler(uint8_t rxBuf[], uint8_t bData)
{
	static uint8_t RX_Status = 0;						//接收状态
	static uint8_t CS = 0;		  						//接收核验和
	static uint16_t RX_Size = 0;						//接收通讯数据长度
	static uint16_t RX_ByteCount = 0;	  		//接收数据字节计数
	
// 	printf("U3 = %02X\r\n", bData);
	
	switch(RX_Status)
	{
		case 0:	  //第一前导字节
			if(bData == 0xfe){
				RX_Status = 1;
			}else{
				RX_Status = 0;
			}
			break;
			
		case 1:	  //第二前导字节
			if(bData == 0xfe){
				RX_Status = 1;						//还是前导字节
			}else if(bData == 0x68){
				RX_Status = 3;						//转到接收设备通讯地址
				CS = 0x68;
			}else{
				RX_Status = 0;
			}
			break;

		case 3:		//接收设备通讯地址
			rxBuf[0] = bData;
			CS += bData;
			RX_Status = 4;
			break;
			
		case 4:	  //接收帧头
			if(bData == 0x68){
				RX_Status = 5;						//转到接收通讯命令
				CS += 0x68;
			}else{
				RX_Status = 0;
			}
			break;
		case 5:		//接收通讯命令
			rxBuf[1] = bData;
			CS += bData;
			RX_Status = 6;							//转到接收数据长度
			break;
			
		case 6:		//接收通讯数据长度（高8位）
			rxBuf[2] = bData;
			CS += bData;
			RX_Status = 62;							//转到接收数据
			break;
			
		case 62:		//接收通讯数据长度（低8位）
			rxBuf[3] = bData;
			CS += bData;
			RX_Size = (rxBuf[2] << 8) | rxBuf[3];				//接收的数据长度
			if(RX_Size == 0x00){			//如果数据长度为0，则直接转到接收校验码
				RX_Status = 8;
			}else{
				RX_ByteCount = 0;
				RX_Status = 7;						//转到接收数据
			}
			break;	
			
		case 7:	  //接收N个字节数据
			if(RX_ByteCount < RX_Size-1){
				rxBuf[RX_ByteCount + 4] = bData;
				CS += bData;
				RX_ByteCount++;
			}else{
				rxBuf[RX_ByteCount + 4] = bData;
				CS += bData;
				RX_ByteCount = 0;					//已完成N个字节的数据接收计数归0
				RX_Status = 8;						//转到接收核验码
			}
			break;
			
		case 8:	  //接收校验
			if(CS != bData){
				RX_Status = 0;
			}else{
				RX_Status = 9;						//转到接收帧尾码0x16
			}
			break;
			
		case 9:	  //接收帧尾
			if(bData == 0x16) 					//是帧尾吗？
			{
				USART4_RX_STA = 0xfd; 	//一帧接收成功，标记接收到一帧数据通知主程序进行通讯处理
			}
			RX_Status = 0;
			break;
			
		default:  //其它
			RX_Status = 0;
			break;
	}
}

/******************** (C) COPYRIGHT 2017 YNHB *****END OF FILE*******************/
